----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:29:55 05/16/2012 
-- Design Name: 
-- Module Name:    encryptor - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity encryptor is
    Port ( dclk : in  STD_LOGIC;
           key : in  STD_LOGIC_VECTOR (7 downto 0);
           din : in  STD_LOGIC_VECTOR (7 downto 0);
           dout : out  STD_LOGIC_VECTOR (7 downto 0);
           kset : in  STD_LOGIC);
end encryptor;

architecture Behavioral of encryptor is
begin

	process (dclk,kset,din)
	begin
		if(dclk='1')then
			if(kset='1')then
				dout<=key XOR din;
			else
				dout<=din;
			end if;
		end if;
	end process;

end Behavioral;

