----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:35:26 05/16/2012 
-- Design Name: 
-- Module Name:    keycontrol - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity keycontrol is
    Port ( din : in  STD_LOGIC_VECTOR(7 downto 0);
           dclk : in  STD_LOGIC;
           rst : in  STD_LOGIC;
           kset : in  STD_LOGIC;
           key : out  STD_LOGIC_VECTOR (7 downto 0));
end keycontrol;

architecture Behavioral of keycontrol is
signal encryption_key: std_logic_vector(7 downto 0):="11111111";
begin
	process(rst,din,dclk)
	begin
		if(dclk='0')then
			if(rst='1')then
				encryption_key<="00000000";--resets the key
			elsif(kset='0' and rst='0')then
				encryption_key<=din;--updates the key when kset is 0
			end if;
		end if;
		if(dclk='1' and dclk'EVENT)then
			key<=encryption_key;
		end if;
	end process;
end Behavioral;

